openapi: 3.0.1
info:
  title: Teste Codesh backend PHP
  description: CRUD Products
  version: '0.1'
servers:
  - url: 'http://localhost:8000'
paths:
  /products:
    get:
      description: Get all products
      responses:
        '200':
          description: OK
    post:
      description: Create product
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                filename:
                  type: string
                price:
                  type: number
                width:
                  type: integer
                rating:
                  type: integer
                description:
                  type: string
                id:
                  type: integer
                title:
                  type: string
                type:
                  type: string
                height:
                  type: integer
            examples:
              '0':
                value: |-
                  {
                      "id": 1,
                      "title": "Brown eggs",
                      "type": "dairy",
                      "description": "Raw organic brown eggs in a basket",
                      "filename": "0.jpg",
                      "price": 28.1,
                      "width": 400,
                      "height": 600,
                      "rating": 4
                  }
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                type: object
                properties:
                  filename:
                    type: string
                  price:
                    type: number
                  width:
                    type: integer
                  rating:
                    type: integer
                  description:
                    type: string
                  id:
                    type: integer
                  title:
                    type: string
                  type:
                    type: string
                  height:
                    type: integer
              examples:
                '0':
                  value: >-
                    {"title":"Brown eggs","type":"dairy","description":"Raw
                    organic brown eggs in a
                    basket","filename":"0.jpg","price":28.1,"width":400,"height":600,"rating":4,"id":53}
        '422':
          description: mandatory field not filled
  /products/{id}:
    get:
      description: Get product specific
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  filename:
                    type: string
                  price:
                    type: number
                  width:
                    type: integer
                  rating:
                    type: integer
                  description:
                    type: string
                  id:
                    type: integer
                  title:
                    type: string
                  type:
                    type: string
                  height:
                    type: integer
              examples:
                '0':
                  value: >-
                    {"id":1,"title":"Brown
                    eggs","type":"dairy","description":"Raw organic brown eggs
                    in a
                    basket","filename":"0.jpg","price":28.1,"width":400,"height":600,"rating":4}
    put:
      description: Update a specific product
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                filename:
                  type: string
                price:
                  type: number
                width:
                  type: integer
                rating:
                  type: integer
                description:
                  type: string
                title:
                  type: string
                type:
                  type: string
                height:
                  type: integer
            examples:
              '0':
                value: |-
                  {
                      "title": "Brown eggs",
                      "type": "dairy",
                      "description": "Raw organic brown eggs in a basket",
                      "filename": "0.jpg",
                      "price": 28.1,
                      "width": 400,
                      "height": 600,
                      "rating": 2
                  }
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  filename:
                    type: string
                  price:
                    type: number
                  width:
                    type: integer
                  rating:
                    type: integer
                  description:
                    type: string
                  id:
                    type: integer
                  title:
                    type: string
                  type:
                    type: string
                  height:
                    type: integer
              examples:
                '0':
                  value: >-
                    {"id":53,"title":"Brown
                    eggs","type":"dairy","description":"Raw organic brown eggs
                    in a
                    basket","filename":"0.jpg","price":28.1,"width":400,"height":600,"rating":2}
        '422':
          description: mandatory field not filled
    delete:
      description: Delete ID product
      responses:
        '200':
          description: Deleted successfully
          content:
            text/html; charset=UTF-8:
              schema:
                type: string
